#version 150
/// BEGIN AUTOGENERATED HEADER
#define CONC(a,b) a##b

#define IF(c, t, e) CONC(IF_, c)(t, e)

#define IF_UNDEF(t, e) e
#define IF_0(t, e) t
#define IF_1(t, e) t
#define IF_2(t, e) t
#define IF_3(t, e) t
#define IF_4(t, e) t
#define IF_5(t, e) t
#define IF_6(t, e) t
#define IF_7(t, e) t
#define IF_8(t, e) t
#define IF_9(t, e) t
#define IF_10(t, e) t
#define IF_11(t, e) t
#define IF_12(t, e) t
#define IF_13(t, e) t
#define IF_14(t, e) t
#define IF_15(t, e) t
#define IF_16(t, e) t
// Workaround for intel HD:
#define IF_00(t, e) t
#ifdef UG_COMPILE_SPIRV
	#define gl_VertexID gl_VertexIndex

	#define LAYOUT_SAMPLER2(s, b) layout(set = s, binding = b)
	#define LAYOUT_SAMPLER(s, b) layout(set = s, binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, set = s, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(push_constant, std140)
	#define LAYOUT_STORAGE(s, b) layout(std140, set = s, binding = b) readonly restrict buffer

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) IF(loc, layout (location = loc) mod in type name, const type name = defaultValue)
		
	#define INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)

	#define OUTPUT(loc, type, name) IF(loc, layout (location = loc) out type name, type name)
	
	#define OUTPUT_MOD(loc, mod, type, name) IF(loc, layout (location = loc) mod out type name, type name)
	
	#define WINDING ccw

	#define LOCATION(loc) layout(location = loc) 
#else
	#extension GL_ARB_separate_shader_objects : require
	#extension GL_ARB_explicit_attrib_location : require
	#extension GL_ARB_shading_language_420pack : require

#ifdef USE_SAMPLER2
	#define LAYOUT_SAMPLER2(s, b)
#else
	#define LAYOUT_SAMPLER2(s, b) layout(binding = b)
#endif

	#define LAYOUT_SAMPLER(s, b) layout(binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(std140, binding = 2)
	#define LAYOUT_STORAGE(s, b) layout(std140, binding = b) buffer

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) mod in type name
		
	#define INPUT(loc, type, name, defaultValue) in type name

	#define OUTPUT(loc, type, name) out type name
	
	#define OUTPUT_MOD(loc, mod, type, name) mod out type name
	
	#define WINDING ccw

	#define LOCATION(loc)
#endif
/// END AUTOGENERATED HEADER

LAYOUT_SAMPLER(2, 23) uniform sampler2D albedoTex;
LAYOUT_SAMPLER(2, 24) uniform sampler2D metalGlossAoTex;
LAYOUT_SAMPLER(2, 25) uniform sampler2D normalTex;
LAYOUT_SAMPLER(2, 26) uniform sampler2D opTex1;
LAYOUT_SAMPLER(2, 27) uniform sampler2D opTex2;
LAYOUT_SAMPLER(2, 28) uniform sampler2D aoTex;

LAYOUT_UBO(1, 3) uniform Material {
	vec4 albedoScales[16];

	float normalScale;

	ivec2 opSettings1;
	vec2 opScale1;
	float opOpacity1;

	ivec2 opSettings2;
	vec2 opScale2;
	float opOpacity2;

	bool flipNormal;
} u_mat;


INPUT(POS_LOC, vec4, posAmbient, vec4(1.0));
INPUT(NRML_LOC, vec3, normal_, vec3(1.0));
INPUT(TNGT_LOC, vec3, tangent_, vec3(1.0));
INPUT(BINORM_LOC, vec3, binormal_, vec3(1.0));
INPUT_MOD(TC_LOC, centroid, vec3, texCoordAlpha, vec3(1.0));
INPUT(TC_1_LOC, vec2, texCoord1, vec2(1.0));

vec3 getUvPos(vec3 posAmbient, vec3 texCoordAlpha, vec3 normal, vec3 tangent, vec3 binormal, 
		sampler2D tex, int mode, vec2 scale, bool flipNormal);
vec3 decodeNormalScale(vec2 color, float scale);
vec3 getFaceNormal(vec3 normal_, bool flip);
vec3 getNormalMapped(vec3 texNormal, vec3 normal_, vec3 binormal_, vec3 tangent_, bool flip);
vec3 applyOp(vec3 pos, vec3 nrml, vec2 texCoord, sampler2D tex, ivec2 settings, vec2 scale, float opacity, vec3 color);
void fragmentOutput(vec3 pos, float ambient, vec3 normal, vec3 albedo, float metalness, float glossiness, float alpha);
void fragmentOutputLightMap(vec3 pos, float ambient, vec3 normal, vec3 albedo, float metalness, float glossiness, float alpha, float brightness);

void main() {
	vec3 faceNormal = getFaceNormal(normal_, u_mat.flipNormal);
	
	vec3 texCoordAlpha = getUvPos(posAmbient.xyz, texCoordAlpha, normal_, tangent_, binormal_, 
		opTex1, u_mat.opSettings1.y /* op1 mode */, u_mat.opScale1, u_mat.flipNormal);

	vec3 texNormal = decodeNormalScale(texture(normalTex, texCoordAlpha.xy).rg, u_mat.normalScale);
	vec3 normal = getNormalMapped(texNormal, normal_, binormal_, tangent_, u_mat.flipNormal);

	vec3 albedo = texture(albedoTex, texCoordAlpha.xy).rgb;

	if (u_mat.opSettings1.y < 3) {
		albedo = applyOp(posAmbient.xyz, faceNormal, texCoordAlpha.xy, opTex1, u_mat.opSettings1, u_mat.opScale1, u_mat.opOpacity1, albedo);
	}
	albedo = applyOp(posAmbient.xyz, faceNormal, texCoordAlpha.xy, opTex2, u_mat.opSettings2, u_mat.opScale2, u_mat.opOpacity2, albedo);

	vec3 metalGlossAo = texture(metalGlossAoTex, texCoordAlpha.xy).rgb;

	vec4 aoCol = texture(aoTex, texCoord1);
	metalGlossAo.b *= clamp(aoCol.r - .5, .0, .5) * 2.0;

	float ambient = min(posAmbient.w, metalGlossAo.b);

	if (u_mat.opSettings1.y > 2 && u_mat.opOpacity1 < 0) {
		fragmentOutputLightMap(posAmbient.xyz, ambient, normal, albedo * u_mat.albedoScales[0].xyz, metalGlossAo.r, metalGlossAo.g, texCoordAlpha.z, aoCol.g);
	} else {
		fragmentOutput(posAmbient.xyz, ambient, normal, albedo * u_mat.albedoScales[0].xyz, metalGlossAo.r, metalGlossAo.g, texCoordAlpha.z);
	}
}
